From 3827caa8c93b295c96a95aad078daeba99e33a04 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Wed, 30 Oct 2019 15:18:56 +0100
Subject: [PATCH] fonts: add Muli (#37367)

---
 README                                        |   8 +++++++
 static/fonts/Muli/muli-bold-webfont.woff      | Bin 0 -> 25076 bytes
 static/fonts/Muli/muli-bold-webfont.woff2     | Bin 0 -> 18760 bytes
 .../fonts/Muli/muli-bolditalic-webfont.woff   | Bin 0 -> 28088 bytes
 .../fonts/Muli/muli-bolditalic-webfont.woff2  | Bin 0 -> 21272 bytes
 .../fonts/Muli/muli-extralight-webfont.woff   | Bin 0 -> 24416 bytes
 .../fonts/Muli/muli-extralight-webfont.woff2  | Bin 0 -> 18304 bytes
 .../Muli/muli-extralightitalic-webfont.woff   | Bin 0 -> 27444 bytes
 .../Muli/muli-extralightitalic-webfont.woff2  | Bin 0 -> 20664 bytes
 static/fonts/Muli/muli-light-webfont.woff     | Bin 0 -> 24620 bytes
 static/fonts/Muli/muli-light-webfont.woff2    | Bin 0 -> 18456 bytes
 .../fonts/Muli/muli-lightitalic-webfont.woff  | Bin 0 -> 27816 bytes
 .../fonts/Muli/muli-lightitalic-webfont.woff2 | Bin 0 -> 21032 bytes
 static/fonts/Muli/muli-regular-webfont.woff   | Bin 0 -> 24432 bytes
 static/fonts/Muli/muli-regular-webfont.woff2  | Bin 0 -> 18252 bytes
 .../Muli/muli-regularitalic-webfont.woff      | Bin 0 -> 27604 bytes
 .../Muli/muli-regularitalic-webfont.woff2     | Bin 0 -> 20872 bytes
 .../Muli/muli-semi-bolditalic-webfont.woff    | Bin 0 -> 27512 bytes
 .../Muli/muli-semi-bolditalic-webfont.woff2   | Bin 0 -> 20784 bytes
 static/fonts/Muli/muli-semibold-webfont.woff  | Bin 0 -> 24392 bytes
 static/fonts/Muli/muli-semibold-webfont.woff2 | Bin 0 -> 18056 bytes
 static/includes/_font-muli.scss               |  22 ++++++++++++++++++
 22 files changed, 30 insertions(+)
 create mode 100644 static/fonts/Muli/muli-bold-webfont.woff
 create mode 100644 static/fonts/Muli/muli-bold-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-bolditalic-webfont.woff
 create mode 100644 static/fonts/Muli/muli-bolditalic-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-extralight-webfont.woff
 create mode 100644 static/fonts/Muli/muli-extralight-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-extralightitalic-webfont.woff
 create mode 100644 static/fonts/Muli/muli-extralightitalic-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-light-webfont.woff
 create mode 100644 static/fonts/Muli/muli-light-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-lightitalic-webfont.woff
 create mode 100644 static/fonts/Muli/muli-lightitalic-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-regular-webfont.woff
 create mode 100644 static/fonts/Muli/muli-regular-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-regularitalic-webfont.woff
 create mode 100644 static/fonts/Muli/muli-regularitalic-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-semi-bolditalic-webfont.woff
 create mode 100644 static/fonts/Muli/muli-semi-bolditalic-webfont.woff2
 create mode 100644 static/fonts/Muli/muli-semibold-webfont.woff
 create mode 100644 static/fonts/Muli/muli-semibold-webfont.woff2
 create mode 100644 static/includes/_font-muli.scss

diff --git a/README b/README
index efb4779d..79fc422f 100644
--- a/README
+++ b/README
@@ -234,6 +234,14 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/quattrocento-sans
 
+* Muli
+  # Copyright (c) 2011 by vernon adams (vern@newtypography.co.uk),
+  # with Reserved Font Name “Muli”.
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://www.fontsquirrel.com/license/muli
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/Muli/muli-bold-webfont.woff b/static/fonts/Muli/muli-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..c6729bc5b6bc3f981d228cd8ac14e61aa7c1259d
GIT binary patch
diff --git a/static/fonts/Muli/muli-bold-webfont.woff2 b/static/fonts/Muli/muli-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..909dc52ae65341fa28858dad221a70e43c187094
GIT binary patch
diff --git a/static/fonts/Muli/muli-bolditalic-webfont.woff b/static/fonts/Muli/muli-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2ff9949761409594421555be306a2d76e0612858
GIT binary patch
diff --git a/static/fonts/Muli/muli-bolditalic-webfont.woff2 b/static/fonts/Muli/muli-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..69f95027b2327c829cb109a4f311307c75ffa7a4
GIT binary patch
diff --git a/static/fonts/Muli/muli-extralight-webfont.woff b/static/fonts/Muli/muli-extralight-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..9f2f195da644e378e15c78044b125c567e7a16fa
GIT binary patch
diff --git a/static/fonts/Muli/muli-extralight-webfont.woff2 b/static/fonts/Muli/muli-extralight-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a4b22f1b8fe7d77404fea4b6fffbf05aaa76d80c
GIT binary patch
diff --git a/static/fonts/Muli/muli-extralightitalic-webfont.woff b/static/fonts/Muli/muli-extralightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..7f51faba6c2f5cd6e7b7b2ea483c9c50bdfb4253
GIT binary patch
diff --git a/static/fonts/Muli/muli-extralightitalic-webfont.woff2 b/static/fonts/Muli/muli-extralightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..13602a4d54f26c90b95521b5583d8b17d4da23a3
GIT binary patch
diff --git a/static/fonts/Muli/muli-light-webfont.woff b/static/fonts/Muli/muli-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..9946f77301db71fdbabe36a25e9367dc2f52b4ed
GIT binary patch
diff --git a/static/fonts/Muli/muli-light-webfont.woff2 b/static/fonts/Muli/muli-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..344cc3f0c4dabdffc895f57956971c678140b1cf
GIT binary patch
diff --git a/static/fonts/Muli/muli-lightitalic-webfont.woff b/static/fonts/Muli/muli-lightitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..b5245ba44b4213e3f58d15a724b34fcebc34ac95
GIT binary patch
diff --git a/static/fonts/Muli/muli-lightitalic-webfont.woff2 b/static/fonts/Muli/muli-lightitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..6d338d191e599903a7ccf7b3638ad2fed1c8facd
GIT binary patch
diff --git a/static/fonts/Muli/muli-regular-webfont.woff b/static/fonts/Muli/muli-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..a9357f4d52ad18834221f7cfc4a87cf5fc734c5b
GIT binary patch
diff --git a/static/fonts/Muli/muli-regular-webfont.woff2 b/static/fonts/Muli/muli-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5a8a0bbbc80600b096ec7321399f3e8afa0f791b
GIT binary patch
diff --git a/static/fonts/Muli/muli-regularitalic-webfont.woff b/static/fonts/Muli/muli-regularitalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4ef655395eee6cac678a05074cf2eecaec4daec9
GIT binary patch
diff --git a/static/fonts/Muli/muli-regularitalic-webfont.woff2 b/static/fonts/Muli/muli-regularitalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..543ed749d761730695b7cda27651efe4e4f2bf31
GIT binary patch
diff --git a/static/fonts/Muli/muli-semi-bolditalic-webfont.woff b/static/fonts/Muli/muli-semi-bolditalic-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..43a19f3db4b276fc94e4ffad8163ee9fdbb7d13f
GIT binary patch
diff --git a/static/fonts/Muli/muli-semi-bolditalic-webfont.woff2 b/static/fonts/Muli/muli-semi-bolditalic-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..341cb0b5b4b2f54445e2f76e7b79df52be835a43
GIT binary patch
diff --git a/static/fonts/Muli/muli-semibold-webfont.woff b/static/fonts/Muli/muli-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..e943cf90c9afe5c38fd0ac6d2715269a71ed7b1d
GIT binary patch
diff --git a/static/fonts/Muli/muli-semibold-webfont.woff2 b/static/fonts/Muli/muli-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..89d657cdaaabb55437571aec34996fd737284535
GIT binary patch
diff --git a/static/includes/_font-muli.scss b/static/includes/_font-muli.scss
new file mode 100644
index 00000000..e628fba9
--- /dev/null
+++ b/static/includes/_font-muli.scss
@@ -0,0 +1,22 @@
+$muli-font-path: '/static/fonts/Muli' !default;
+
+@mixin muli-font($type, $weight, $style: normal) {
+	@font-face {
+		font-family: 'Muli';
+		src: url('#{$muli-font-path}/muli-#{$type}-webfont.woff2') format('woff2'),
+		     url('#{$muli-font-path}/muli-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: $style;
+	}
+}
+
+@mixin muli-font-pair($type, $weight) {
+	@include muli-font($type, $weight);
+	@include muli-font(#{$type}italic, $weight, italic);
+}
+
+@include muli-font-pair('extraLight', 200);
+@include muli-font-pair('light', 300);
+@include muli-font-pair('regular', 400);
+@include muli-font-pair('semibold', 600);
+@include muli-font-pair('bold', 700);
-- 
2.24.0.rc1